diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-header.h ns-3.44/src/lr-wpan/model/lr-wpan-mac-header.h
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-header.h	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-header.h	2025-03-09 16:55:49.419371100 -0700
@@ -26,9 +26,9 @@
 #ifndef LR_WPAN_MAC_HEADER_H
 #define LR_WPAN_MAC_HEADER_H
 
-#include <ns3/header.h>
-#include <ns3/mac16-address.h>
-#include <ns3/mac64-address.h>
+#include "ns3/header.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
 
 namespace ns3
 {
@@ -36,7 +36,7 @@
 {
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  * Represent the Mac Header with the Frame Control and Sequence Number fields
  */
 class LrWpanMacHeader : public Header
@@ -80,10 +80,10 @@
 
     /**
      * Constructor
-     * \param wpanMacType the header MAC type
-     * \param seqNum the sequence number
+     * @param wpanMacType the header MAC type
+     * @param seqNum the sequence number
      *
-     * \internal
+     * @internal
      * Data, ACK, Control MAC Header must have frame control and sequence number.
      * Beacon MAC Header must have frame control, sequence number, source PAN Id, source address.
      */
@@ -93,158 +93,158 @@
 
     /**
      * Get the header type
-     * \return the header type
+     * @return the header type
      */
     LrWpanMacType GetType() const;
     /**
      * Get the Frame control field
-     * \return the Frame control field
+     * @return the Frame control field
      */
     uint16_t GetFrameControl() const;
     /**
      * Check if Security Enabled bit of Frame Control is enabled
-     * \return true if Security Enabled bit is enabled
+     * @return true if Security Enabled bit is enabled
      */
     bool IsSecEnable() const;
     /**
      * Check if Frame Pending bit of Frame Control is enabled
-     * \return true if Frame Pending bit is enabled
+     * @return true if Frame Pending bit is enabled
      */
     bool IsFrmPend() const;
     /**
      * Check if Ack. Request bit of Frame Control is enabled
-     * \return true if Ack. Request bit is enabled
+     * @return true if Ack. Request bit is enabled
      */
     bool IsAckReq() const;
     /**
      * Check if PAN ID Compression bit of Frame Control is enabled
-     * \return true if PAN ID Compression bit is enabled
+     * @return true if PAN ID Compression bit is enabled
      */
     bool IsPanIdComp() const;
     /**
      * Get the Reserved bits of Frame control field
-     * \return the Reserved bits
+     * @return the Reserved bits
      */
     uint8_t GetFrmCtrlRes() const;
     /**
      * Get the Dest. Addressing Mode of Frame control field
-     * \return the Dest. Addressing Mode bits
+     * @return the Dest. Addressing Mode bits
      */
     uint8_t GetDstAddrMode() const;
     /**
      * Get the Frame Version of Frame control field
-     * \return the Frame Version bits
+     * @return the Frame Version bits
      */
     uint8_t GetFrameVer() const;
     /**
      * Get the Source Addressing Mode of Frame control field
-     * \return the Source Addressing Mode bits
+     * @return the Source Addressing Mode bits
      */
     uint8_t GetSrcAddrMode() const;
     /**
      * Get the frame Sequence number
-     * \return the sequence number
+     * @return the sequence number
      */
     uint8_t GetSeqNum() const;
     /**
      * Get the Destination PAN ID
-     * \return the Destination PAN ID
+     * @return the Destination PAN ID
      */
     uint16_t GetDstPanId() const;
     /**
      * Get the Destination Short address
-     * \return the Destination Short address
+     * @return the Destination Short address
      */
     Mac16Address GetShortDstAddr() const;
     /**
      * Get the Destination Extended address
-     * \return the Destination Extended address
+     * @return the Destination Extended address
      */
     Mac64Address GetExtDstAddr() const;
     /**
      * Get the Source PAN ID
-     * \return the Source PAN ID
+     * @return the Source PAN ID
      */
     uint16_t GetSrcPanId() const;
     /**
      * Get the Source Short address
-     * \return the Source Short address
+     * @return the Source Short address
      */
     Mac16Address GetShortSrcAddr() const;
     /**
      * Get the Source Extended address
-     * \return the Source Extended address
+     * @return the Source Extended address
      */
     Mac64Address GetExtSrcAddr() const;
     /**
      * Get the Auxiliary Security Header - Security Control Octet
-     * \return the Auxiliary Security Header - Security Control Octet
+     * @return the Auxiliary Security Header - Security Control Octet
      */
     uint8_t GetSecControl() const;
     /**
      * Get the Auxiliary Security Header - Frame Counter Octets
-     * \return the Auxiliary Security Header - Frame Counter Octets
+     * @return the Auxiliary Security Header - Frame Counter Octets
      */
     uint32_t GetFrmCounter() const;
 
     /**
      * Get the Auxiliary Security Header - Security Control - Security Level bits
-     * \return the Auxiliary Security Header - Security Control - Security Level bits
+     * @return the Auxiliary Security Header - Security Control - Security Level bits
      */
     uint8_t GetSecLevel() const;
     /**
      * Get the Auxiliary Security Header - Security Control - Key Identifier Mode bits
-     * \return the Auxiliary Security Header - Security Control - Key Identifier Mode bits
+     * @return the Auxiliary Security Header - Security Control - Key Identifier Mode bits
      */
     uint8_t GetKeyIdMode() const;
     /**
      * Get the Auxiliary Security Header - Security Control - Reserved bits
-     * \return the Auxiliary Security Header - Security Control - Reserved bits
+     * @return the Auxiliary Security Header - Security Control - Reserved bits
      */
     uint8_t GetSecCtrlReserved() const;
     /**
      * Get the Auxiliary Security Header - Key Identifier - Key Source (2 Octets)
-     * \return the Auxiliary Security Header - Key Identifier - Key Source  (2 Octets)
+     * @return the Auxiliary Security Header - Key Identifier - Key Source  (2 Octets)
      */
     uint32_t GetKeyIdSrc32() const;
     /**
      * Get the Auxiliary Security Header - Key Identifier - Key Source (4 Octets)
-     * \return the Auxiliary Security Header - Key Identifier - Key Source  (4 Octets)
+     * @return the Auxiliary Security Header - Key Identifier - Key Source  (4 Octets)
      */
     uint64_t GetKeyIdSrc64() const;
     /**
      * Get the Auxiliary Security Header - Key Identifier - Key Index
-     * \return the Auxiliary Security Header - Key Identifier - Key Index
+     * @return the Auxiliary Security Header - Key Identifier - Key Index
      */
     uint8_t GetKeyIdIndex() const;
     /**
      * Returns true if the header is a beacon
-     * \return true if the header is a beacon
+     * @return true if the header is a beacon
      */
     bool IsBeacon() const;
     /**
      * Returns true if the header is a data
-     * \return true if the header is a data
+     * @return true if the header is a data
      */
     bool IsData() const;
     /**
      * Returns true if the header is an ack
-     * \return true if the header is an ack
+     * @return true if the header is an ack
      */
     bool IsAcknowledgment() const;
     /**
      * Returns true if the header is a command
-     * \return true if the header is a command
+     * @return true if the header is a command
      */
     bool IsCommand() const;
     /**
      * Set the Frame Control field "Frame Type" bits
-     * \param wpanMacType the frame type
+     * @param wpanMacType the frame type
      */
     void SetType(LrWpanMacType wpanMacType);
     /**
      * Set the whole Frame Control field
-     * \param frameControl the Frame Control field
+     * @param frameControl the Frame Control field
      */
     void SetFrameControl(uint16_t frameControl);
     /**
@@ -281,102 +281,102 @@
     void SetNoPanIdComp();
     /**
      * Set the Frame Control field "Reserved" bits
-     * \param res reserved bits
+     * @param res reserved bits
      */
     void SetFrmCtrlRes(uint8_t res);
     /**
      * Set the Destination address mode
-     * \param addrMode Destination address mode
+     * @param addrMode Destination address mode
      */
     void SetDstAddrMode(uint8_t addrMode);
     /**
      * Set the Frame version
-     * \param ver frame version
+     * @param ver frame version
      */
     void SetFrameVer(uint8_t ver);
     /**
      * Set the Source address mode
-     * \param addrMode Source address mode
+     * @param addrMode Source address mode
      */
     void SetSrcAddrMode(uint8_t addrMode);
     /**
      * Set the Sequence number
-     * \param seqNum sequence number
+     * @param seqNum sequence number
      */
     void SetSeqNum(uint8_t seqNum);
     /* The Source/Destination Addressing fields are only set if SrcAddrMode/DstAddrMode are set */
     /**
      * Set Source address fields
-     * \param panId source PAN ID
-     * \param addr source address (16 bit)
+     * @param panId source PAN ID
+     * @param addr source address (16 bit)
      */
     void SetSrcAddrFields(uint16_t panId, Mac16Address addr);
     /**
      * Set Source address fields
-     * \param panId source PAN ID
-     * \param addr source address (64 bit)
+     * @param panId source PAN ID
+     * @param addr source address (64 bit)
      */
     void SetSrcAddrFields(uint16_t panId, Mac64Address addr);
     /**
      * Set Destination address fields
-     * \param panId destination PAN ID
-     * \param addr destination address (16 bit)
+     * @param panId destination PAN ID
+     * @param addr destination address (16 bit)
      */
     void SetDstAddrFields(uint16_t panId, Mac16Address addr);
     /**
      * Set Destination address fields
-     * \param panId destination PAN ID
-     * \param addr destination address (64 bit)
+     * @param panId destination PAN ID
+     * @param addr destination address (64 bit)
      */
     void SetDstAddrFields(uint16_t panId, Mac64Address addr);
 
     /* Auxiliary Security Header is only set if Sec Enable (SecU) field is set to 1 */
     /**
      * Set the auxiliary security header "Security Control" octet
-     * \param secLevel the "Security Control" octet
+     * @param secLevel the "Security Control" octet
      */
     void SetSecControl(uint8_t secLevel);
     /**
      * Set the auxiliary security header "Frame Counter" octet
-     * \param frmCntr the "Frame Counter" octet
+     * @param frmCntr the "Frame Counter" octet
      */
     void SetFrmCounter(uint32_t frmCntr);
     /**
      * Set the Security Control field "Security Level" bits (3 bits)
-     * \param secLevel the "Security Level" bits
+     * @param secLevel the "Security Level" bits
      */
     void SetSecLevel(uint8_t secLevel);
     /**
      * Set the Security Control field "Key Identifier Mode" bits (2 bits)
-     * \param keyIdMode the "Key Identifier Mode" bits
+     * @param keyIdMode the "Key Identifier Mode" bits
      */
     void SetKeyIdMode(uint8_t keyIdMode);
     /**
      * Set the Security Control field "Reserved" bits (3 bits)
-     * \param res the "Reserved" bits
+     * @param res the "Reserved" bits
      */
     void SetSecCtrlReserved(uint8_t res);
     /* Variable length will be dependent on Key Id Mode*/
     /**
      * Set the Key Index
-     * \param keyIndex the Key index
+     * @param keyIndex the Key index
      */
     void SetKeyId(uint8_t keyIndex);
     /**
      * Set the Key Index and originator
-     * \param keySrc the originator of a group key
-     * \param keyIndex the Key index
+     * @param keySrc the originator of a group key
+     * @param keyIndex the Key index
      */
     void SetKeyId(uint32_t keySrc, uint8_t keyIndex);
     /**
      * Set the Key Index and originator
-     * \param keySrc the originator of a group key
-     * \param keyIndex the Key index
+     * @param keySrc the originator of a group key
+     * @param keyIndex the Key index
      */
     void SetKeyId(uint64_t keySrc, uint8_t keyIndex);
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc ns-3.44/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2025-03-09 16:55:49.419371100 -0700
@@ -8,8 +8,8 @@
 
 #include "lr-wpan-mac-pl-headers.h"
 
-#include <ns3/address-utils.h>
-#include <ns3/simulator.h>
+#include "ns3/address-utils.h"
+#include "ns3/simulator.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.44/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2025-03-09 16:55:49.419371100 -0700
@@ -11,9 +11,9 @@
 
 #include "lr-wpan-fields.h"
 
-#include <ns3/header.h>
-#include <ns3/mac16-address.h>
-#include <ns3/mac64-address.h>
+#include "ns3/header.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
 
 namespace ns3
 {
@@ -21,7 +21,7 @@
 {
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  * Implements the header for the MAC payload beacon frame according to
  * the IEEE 802.15.4-2011 Std.
  */
@@ -30,8 +30,8 @@
   public:
     BeaconPayloadHeader();
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -41,32 +41,32 @@
     void Print(std::ostream& os) const override;
     /**
      * Set the superframe specification field to the beacon payload header.
-     * \param sfrmField The superframe specification field (bitmap)
+     * @param sfrmField The superframe specification field (bitmap)
      */
     void SetSuperframeSpecField(uint16_t sfrmField);
     /**
      * Set the superframe Guaranteed Time Slot (GTS) fields to the beacon payload header.
-     * \param gtsFields The GTS fields.
+     * @param gtsFields The GTS fields.
      */
     void SetGtsFields(GtsFields gtsFields);
     /**
      * Set the superframe Pending Address fields to the beacon payload header.
-     * \param pndAddrFields The Pending Address fields.
+     * @param pndAddrFields The Pending Address fields.
      */
     void SetPndAddrFields(PendingAddrFields pndAddrFields);
     /**
      * Get the superframe specification field from the beacon payload header.
-     * \return The superframe specification field (bitmap)
+     * @return The superframe specification field (bitmap)
      */
     uint16_t GetSuperframeSpecField() const;
     /**
      * Get the Guaranteed Time Slots (GTS) fields from the beacon payload header.
-     * \return The GTS fields.
+     * @return The GTS fields.
      */
     GtsFields GetGtsFields() const;
     /**
      * Get the pending address fields from the beacon payload header.
-     * \return The Pending Address fields.
+     * @return The Pending Address fields.
      */
     PendingAddrFields GetPndAddrFields() const;
 
@@ -86,7 +86,7 @@
 };
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  * Implements the header for the MAC payload command frame according to
  * the IEEE 802.15.4-2011 Std.
  * - Association Response Command (See 5.3.2.2.)
@@ -117,12 +117,12 @@
     CommandPayloadHeader();
     /**
      * Constructor
-     * \param macCmd the command type of this command header
+     * @param macCmd the command type of this command header
      */
     CommandPayloadHeader(MacCommand macCmd);
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -133,86 +133,86 @@
 
     /**
      * Set the command frame type
-     * \param macCmd the command frame type
+     * @param macCmd the command frame type
      */
     void SetCommandFrameType(MacCommand macCmd);
     /**
      * Set the Capability Information Field to the command payload header (Association Request
      * Command).
-     * \param cap The capability Information field
+     * @param cap The capability Information field
      */
     void SetCapabilityField(uint8_t cap);
     /**
      *  Set the coordinator short address (16 bit address).
-     * \param addr The coordinator short address.
+     * @param addr The coordinator short address.
      */
     void SetCoordShortAddr(Mac16Address addr);
     /**
      *  Set the logical channel number.
-     * \param channel The channel number.
+     * @param channel The channel number.
      */
     void SetChannel(uint8_t channel);
     /**
      *  Set the logical channel page number.
-     * \param page The page number.
+     * @param page The page number.
      */
     void SetPage(uint8_t page);
     /**
      * Get the PAN identifier.
-     * \param id The PAN identifier.
+     * @param id The PAN identifier.
      */
     void SetPanId(uint16_t id);
     /**
      * Set the Short Address Assigned by the coordinator
      * (Association Response and Coordinator Realigment Commands).
-     * \param shortAddr The short address assigned by the coordinator
+     * @param shortAddr The short address assigned by the coordinator
      */
     void SetShortAddr(Mac16Address shortAddr);
     /**
      * Set status resulting from the association attempt (Association Response Command).
-     * \param status The status resulting from the association attempt
+     * @param status The status resulting from the association attempt
      */
     void SetAssociationStatus(uint8_t status);
     /**
      * Get the Short address assigned by the coordinator
      * (Association Response and Coordinator Realigment commands).
-     * \return The Mac16Address assigned by the coordinator
+     * @return The Mac16Address assigned by the coordinator
      */
     Mac16Address GetShortAddr() const;
     /**
      * Get the status resulting from an association request (Association Response Command).
-     * \return The resulting status from an association request
+     * @return The resulting status from an association request
      */
     uint8_t GetAssociationStatus() const;
     /**
      * Get the command frame type ID
-     * \return The command type ID from the command payload header
+     * @return The command type ID from the command payload header
      */
     MacCommand GetCommandFrameType() const;
     /**
      * Get the Capability Information Field from the command payload header.
      * (Association Request Command)
-     * \return The Capability Information Field (8 bit bitmap)
+     * @return The Capability Information Field (8 bit bitmap)
      */
     uint8_t GetCapabilityField() const;
     /**
      *  Get the coordinator short address.
-     * \return The coordinator short address (16 bit address)
+     * @return The coordinator short address (16 bit address)
      */
     Mac16Address GetCoordShortAddr() const;
     /**
      *  Get the logical channel number.
-     * \return The channel number
+     * @return The channel number
      */
     uint8_t GetChannel() const;
     /**
      *  Get the logical channel page number.
-     * \return The page number.
+     * @return The page number.
      */
     uint8_t GetPage() const;
     /**
      * Get the PAN identifier.
-     * \return The PAN Identifier
+     * @return The PAN Identifier
      */
     uint16_t GetPanId() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-trailer.cc ns-3.44/src/lr-wpan/model/lr-wpan-mac-trailer.cc
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-trailer.cc	2025-03-09 16:55:49.419371100 -0700
@@ -10,7 +10,7 @@
  */
 #include "lr-wpan-mac-trailer.h"
 
-#include <ns3/packet.h>
+#include "ns3/packet.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-mac-trailer.h ns-3.44/src/lr-wpan/model/lr-wpan-mac-trailer.h
--- ns-3.43/src/lr-wpan/model/lr-wpan-mac-trailer.h	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-mac-trailer.h	2025-03-09 16:55:49.419371100 -0700
@@ -12,7 +12,7 @@
 #ifndef LR_WPAN_MAC_TRAILER_H
 #define LR_WPAN_MAC_TRAILER_H
 
-#include <ns3/trailer.h>
+#include "ns3/trailer.h"
 
 namespace ns3
 {
@@ -23,7 +23,7 @@
 {
 
 /**
- * \ingroup lr-wpan
+ * @ingroup lr-wpan
  *
  * Represent the Mac Trailer with the Frame Check Sequence field.
  */
@@ -33,7 +33,7 @@
     /**
      * Get the type ID.
      *
-     * \return the object TypeId
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -53,14 +53,14 @@
      * Get this trailers FCS value. If FCS calculation is disabled for this
      * trailer, the returned value is always 0.
      *
-     * \return the FCS value.
+     * @return the FCS value.
      */
     uint16_t GetFcs() const;
 
     /**
      * Calculate and set the FCS value based on the given packet.
      *
-     * \param p the packet for which the FCS should be calculated
+     * @param p the packet for which the FCS should be calculated
      */
     void SetFcs(Ptr<const Packet> p);
 
@@ -69,22 +69,22 @@
      * trailer. The packet itself should contain no trailer. If FCS calculation is
      * disabled for this trailer, CheckFcs() will always return true.
      *
-     * \param p the packet to be checked
-     * \return false, if the FCS values do not match, true otherwise
+     * @param p the packet to be checked
+     * @return false, if the FCS values do not match, true otherwise
      */
     bool CheckFcs(Ptr<const Packet> p);
 
     /**
      * Enable or disable FCS calculation for this trailer.
      *
-     * \param enable flag, indicating if FCS calculation should be enabled or not
+     * @param enable flag, indicating if FCS calculation should be enabled or not
      */
     void EnableFcs(bool enable);
 
     /**
      * Query if FCS calculation is enabled for this trailer.
      *
-     * \return true, if FCS calculation is enabled, false otherwise.
+     * @return true, if FCS calculation is enabled, false otherwise.
      */
     bool IsFcsEnabled() const;
 
@@ -94,9 +94,9 @@
      * CRC16-CCITT with a generator polynomial = ^16 + ^12 + ^5 + 1, LSB first and
      * initial value = 0x0000.
      *
-     * \param data the checksum will be calculated over this data
-     * \param length the length of the data
-     * \return the checksum
+     * @param data the checksum will be calculated over this data
+     * @param length the length of the data
+     * @return the checksum
      */
     uint16_t GenerateCrc16(uint8_t* data, int length);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/lr-wpan/model/lr-wpan-net-device.cc ns-3.44/src/lr-wpan/model/lr-wpan-net-device.cc
--- ns-3.43/src/lr-wpan/model/lr-wpan-net-device.cc	2024-10-09 16:41:09.900656000 -0700
+++ ns-3.44/src/lr-wpan/model/lr-wpan-net-device.cc	2025-03-09 16:55:49.419371100 -0700
@@ -14,13 +14,13 @@
 #include "lr-wpan-error-model.h"
 #include "lr-wpan-phy.h"
 
-#include <ns3/abort.h>
-#include <ns3/boolean.h>
-#include <ns3/log.h>
-#include <ns3/node.h>
-#include <ns3/packet.h>
-#include <ns3/pointer.h>
-#include <ns3/spectrum-channel.h>
+#include "ns3/abort.h"
+#include "ns3/boolean.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/packet.h"
+#include "ns3/pointer.h"
+#include "ns3/spectrum-channel.h"
 
 namespace ns3
 {
@@ -76,10 +76,10 @@
     : m_configComplete(false)
 {
     NS_LOG_FUNCTION(this);
-    m_mac = CreateObject<LrWpanMac>();
+
     m_phy = CreateObject<LrWpanPhy>();
     m_csmaca = CreateObject<LrWpanCsmaCa>();
-    CompleteConfig();
+    m_mac = CreateObject<LrWpanMac>();
 }
 
 LrWpanNetDevice::~LrWpanNetDevice()
@@ -91,7 +91,6 @@
 LrWpanNetDevice::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    m_mac->Dispose();
     m_phy->Dispose();
     m_csmaca->Dispose();
     m_phy = nullptr;
@@ -106,19 +105,23 @@
 LrWpanNetDevice::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
+
     m_phy->Initialize();
-    m_mac->Initialize();
+    AggregateObject(m_mac);
+    CompleteConfig();
+
     NetDevice::DoInitialize();
 }
 
 void
 LrWpanNetDevice::CompleteConfig()
 {
-    NS_LOG_FUNCTION(this);
     if (!m_mac || !m_phy || !m_csmaca || !m_node || m_configComplete)
     {
         return;
     }
+
+    NS_LOG_FUNCTION(this);
     m_mac->SetPhy(m_phy);
     m_mac->SetCsmaCa(m_csmaca);
     m_mac->SetMcpsDataIndicationCallback(MakeCallback(&LrWpanNetDevice::McpsDataIndication, this));
@@ -146,75 +149,68 @@
 void
 LrWpanNetDevice::SetMac(Ptr<LrWpanMac> mac)
 {
-    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(LrWpanNetDevice::IsInitialized(),
+                    "MAC layer cannot be set after initialization");
     m_mac = mac;
-    CompleteConfig();
 }
 
 void
 LrWpanNetDevice::SetPhy(Ptr<LrWpanPhy> phy)
 {
-    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(LrWpanNetDevice::IsInitialized(),
+                    "PHY layer cannot be set after initialization");
     m_phy = phy;
-    CompleteConfig();
 }
 
 void
 LrWpanNetDevice::SetCsmaCa(Ptr<LrWpanCsmaCa> csmaca)
 {
-    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(LrWpanNetDevice::IsInitialized(), "CSMA/CA cannot be set after initialization");
     m_csmaca = csmaca;
-    CompleteConfig();
 }
 
 void
 LrWpanNetDevice::SetChannel(Ptr<SpectrumChannel> channel)
 {
-    NS_LOG_FUNCTION(this << channel);
+    NS_ABORT_MSG_IF(LrWpanNetDevice::IsInitialized(),
+                    "Spectrum channel cannot be set after initialization");
     m_phy->SetChannel(channel);
     channel->AddRx(m_phy);
-    CompleteConfig();
 }
 
 Ptr<LrWpanMac>
 LrWpanNetDevice::GetMac() const
 {
-    // NS_LOG_FUNCTION (this);
     return m_mac;
 }
 
 Ptr<LrWpanPhy>
 LrWpanNetDevice::GetPhy() const
 {
-    NS_LOG_FUNCTION(this);
     return m_phy;
 }
 
 Ptr<LrWpanCsmaCa>
 LrWpanNetDevice::GetCsmaCa() const
 {
-    NS_LOG_FUNCTION(this);
     return m_csmaca;
 }
 
 void
 LrWpanNetDevice::SetIfIndex(const uint32_t index)
 {
-    NS_LOG_FUNCTION(this << index);
     m_ifIndex = index;
 }
 
 uint32_t
 LrWpanNetDevice::GetIfIndex() const
 {
-    NS_LOG_FUNCTION(this);
     return m_ifIndex;
 }
 
 Ptr<Channel>
 LrWpanNetDevice::GetChannel() const
 {
-    NS_LOG_FUNCTION(this);
     return m_phy->GetChannel();
 }
 
@@ -449,14 +445,12 @@
 Ptr<Node>
 LrWpanNetDevice::GetNode() const
 {
-    NS_LOG_FUNCTION(this);
     return m_node;
 }
 
 void
 LrWpanNetDevice::SetNode(Ptr<Node> node)
 {
-    NS_LOG_FUNCTION(this);
     m_node = node;
     CompleteConfig();
 }
